<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Fueltype;
use App\Models\Fuelcapacity;
use App\Models\Station;

class FuelController extends Controller
{
    // This function for get Fuel Typespes
    public function get_fuel_type(Request $req){
        $fueltype = "";
        if($req->id){
            $fueltype = Fueltype::find($req->id);
        }else{
            $fueltype = Fueltype::all()->orderby('id','DESC');

        }
        return response()->json(['respond'=>$fueltype]);
    }

    
   
     
    // This function for create a new Fuel type
    public function create_fuel_type(Request $req){
        $message = '';

        if($this->check_empty($req->name,$req->price)){
            //create new User
            $fueltype = new Fueltype;
            $fueltype->name = $req->name;
            $fueltype->price = $req->price;
            $fueltype->save();

            $message = 'Fuel Type successfully created';
        }else{
            $message = 'Type or Price cannot be empty';
        }
        return response()->json(['message'=>$message]);
    }

    
    // This function for delete a Fuel type
    public function delete_fuel_type(Request $req){
        $fueltype = Fueltype::find($req->id);
        $fueltype->delete();
        return response()->json(['message'=>'success']);
    }

    // This function for update a Fuel type
    public function update_fuel_type(Request $req){

        $fueltype = Fueltype::find($req->id);

        $fueltype->update([
            'name' => $req->name,
            'price' => $req->price,
        ]);

        return response()->json(['message'=>'success']);
    }